## ubuntuone-credentials 15.11+16.04.20160323

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.9)

# This is the name and release version of the project
PROJECT (ubuntuone-credentials)
SET (PROJECT_VERSION 15.10)

include(GNUInstallDirs)

# Some variables for the library builds
SET (AUTH_LIB_VERSION 0.1.0)
SET (AUTH_LIB_SOVERSION 0)
SET (AUTH_LIB_API_VERSION 2.0)
SET (AUTH_LIB_UNVERSIONED ubuntuoneauth)
SET (AUTH_LIB_NAME ${AUTH_LIB_UNVERSIONED}-${AUTH_LIB_API_VERSION})

# these names are used in qml-credentials-service/qmldir.template
SET (QML_MODULE_NAME UbuntuOne)
SET (QML_PLUGIN_API_VERSION 1.0)
SET (QML_PLUGIN_NAME UbuntuOneCredentialsPlugin-${QML_PLUGIN_API_VERSION})

# For the signon plug-in module
SET (SIGNON_PLUGIN_NAME ubuntuoneplugin)

# Need to get libsignon/accounts here, as they get exposed in headers
find_package (PkgConfig REQUIRED)
pkg_check_modules(LIBSIGNON REQUIRED libsignon-qt5 accounts-qt5)
add_definitions(${LIBSIGNON_CFLAGS} ${LIBSIGNON_CFLAGS_OTHER})

# Some default CFLAGS
SET (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -O2 -g -Wall -Werror -fPIC")
SET (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x -O2 -g -Wall -Werror -fPIC")

# Allow specifying the libdir to use for the C library
SET (LIB_SUFFIX "" CACHE STRING "Define suffix of library directory name.")
SET (LIB_INSTALL_DIR "lib${LIB_SUFFIX}")

set (QML_MODULE_INSTALL_DIR ${LIB_INSTALL_DIR}/qt5/qml )

include_directories(${CMAKE_SOURCE_DIR}/libubuntuoneauth)

# A rule and variables for creating a tarball distribution
SET (ARCHIVE_NAME ${CMAKE_PROJECT_NAME}-${PROJECT_VERSION})
SET (ARCHIVE_FILE ${CMAKE_BINARY_DIR}/${ARCHIVE_NAME}.tar.bz2)
SET (ARCHIVE_ARGS --exclude-vcs --exclude-backups --exclude-from=${CMAKE_SOURCE_DIR}/.bzrignore --transform=\"s,^,${ARCHIVE_NAME}/,\")
add_custom_target(dist
    COMMAND tar -cvjf ${ARCHIVE_FILE} ${ARCHIVE_ARGS} *
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})


add_subdirectory(data)
add_subdirectory(libubuntuoneauth)
add_subdirectory(signon-plugin)
add_subdirectory(qml-credentials-service)
add_subdirectory(online-accounts-provider)
add_subdirectory(po)

# We need to add these here which simply depend on other test rules, as
# CMake doesn't allow defining a "check" rule in multiple places.
# We use $namespace-tests[-valgrind[-leaks]] for the test names in subdirs,
# and depend on them here, so that 'make check' will run them all.
add_custom_target(check
  DEPENDS ubuntuoneauth-tests
)

add_custom_target(check-valgrind
  DEPENDS ubuntuoneauth-tests-valgrind
)

add_custom_target(check-valgrind-leaks
  DEPENDS ubuntuoneauth-tests-valgrind-leaks
)

=== libubuntuoneauth/CMakeLists.txt ===
# Qt5 bits
SET (CMAKE_INCLUDE_CURRENT_DIR ON)
SET (CMAKE_AUTOMOC ON)
find_package(Qt5Core REQUIRED)

# Allow the developer to select if Dynamic or Static libraries are built
OPTION (BUILD_STATIC_LIBS "Build Static Libraries" OFF)

# Set the LIB_TYPE variable to STATIC
SET (LIB_TYPE SHARED)
IF (BUILD_STATIC_LIBS)
  # User wants to build Dynamic Libraries, so change the LIB_TYPE 'STATIC'
  SET (LIB_TYPE STATIC)
ENDIF (BUILD_STATIC_LIBS)

# The sources for building the library
FILE (GLOB SOURCES *.cpp)
# HEADERS only includes the public headers for installation.
FILE (GLOB HEADERS *.h)

pkg_check_modules(OAUTH REQUIRED oauth)
add_definitions(${OAUTH_CFLAGS} ${OAUTH_CFLAGS_OTHER})

# Need the project version here
add_definitions("-DPROJECT_VERSION=\"${PROJECT_VERSION}\"")

add_library (${AUTH_LIB_NAME} ${LIB_TYPE} ${SOURCES})
qt5_use_modules (${AUTH_LIB_NAME} Core DBus Xml Network)
target_link_libraries (${AUTH_LIB_NAME}
  ${LIBSIGNON_LDFLAGS}
  ${OAUTH_LDFLAGS}
  -Wl,--version-script -Wl,${CMAKE_CURRENT_SOURCE_DIR}/libubuntuoneauth.symbols
)

SET_TARGET_PROPERTIES(${AUTH_LIB_NAME} PROPERTIES
  VERSION ${AUTH_LIB_VERSION}
  SOVERSION ${AUTH_LIB_SOVERSION}
)

INSTALL (
  TARGETS ${AUTH_LIB_NAME}
  ARCHIVE DESTINATION ${LIB_INSTALL_DIR}
  LIBRARY DESTINATION ${LIB_INSTALL_DIR}
)

INSTALL (
  FILES ${HEADERS}
  DESTINATION include/${AUTH_LIB_NAME}
)

SET (AUTH_LIB_PKGCONFIG_IN ${AUTH_LIB_UNVERSIONED}.pc.in)
SET (AUTH_LIB_PKGCONFIG ${AUTH_LIB_NAME}.pc)
add_custom_target(${AUTH_LIB_PKGCONFIG}
  ALL sed -e 's|\@PREFIX\@|${CMAKE_INSTALL_PREFIX}|g'
    -e 's|\@LIBDIR\@|${LIB_INSTALL_DIR}|g'
    -e 's|\@VERSION\@|${PROJECT_VERSION}|g'
    -e 's|\@LIB_NAME\@|${AUTH_LIB_NAME}|g' < ${CMAKE_CURRENT_SOURCE_DIR}/${AUTH_LIB_PKGCONFIG_IN} > ${AUTH_LIB_PKGCONFIG}
  SOURCES ${AUTH_LIB_PKGCONFIG_IN}
)

INSTALL (
  FILES ${CMAKE_CURRENT_BINARY_DIR}/${AUTH_LIB_PKGCONFIG}
  DESTINATION ${LIB_INSTALL_DIR}/pkgconfig
)

add_subdirectory(tests)
add_subdirectory(examples)

=== po/CMakeLists.txt ===
include(FindGettext)
find_program(GETTEXT_XGETTEXT_EXECUTABLE xgettext)
find_program(INTLTOOL_UPDATE intltool-update)

set(GETTEXT_PACKAGE ${PROJECT_NAME})
set(POT_FILE ${GETTEXT_PACKAGE}.pot)
file(GLOB POFILES RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.po)

# Creates POTFILES
add_custom_target(POTFILES ALL
    COMMENT "Generating POTFILES"
    COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/genpotfiles.sh ${CMAKE_SOURCE_DIR}
)

# Creates the .pot file containing the translations template
add_custom_target(${POT_FILE}
    COMMENT "Generating translation template"
    COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/genpot.sh ${GETTEXT_XGETTEXT_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR} ${INTLTOOL_UPDATE} ${GETTEXT_PACKAGE}
    COMMAND cp -f ${POT_FILE} ${CMAKE_CURRENT_SOURCE_DIR}/
    VERBATIM
    DEPENDS POTFILES
)

# Builds the binary translations catalog for each language
# it finds source translations (*.po) for
foreach(POFILE ${POFILES})
    string(REPLACE ".po" "" LANG ${POFILE})
    list(APPEND PO_FILES "${POFILE}")
    gettext_process_po_files(${LANG} ALL PO_FILES "${POFILE}")
    set(INSTALL_DIR ${CMAKE_INSTALL_LOCALEDIR}/${LANG}/LC_MESSAGES)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${LANG}.gmo
            DESTINATION ${INSTALL_DIR}
            RENAME ${GETTEXT_PACKAGE}.mo
    )
endforeach(POFILE)

=== qml-credentials-service/CMakeLists.txt ===
# Qt5 bits
set (CMAKE_INCLUDE_CURRENT_DIR ON)
set (CMAKE_AUTOMOC ON)
find_package(Qt5Core REQUIRED)

file (GLOB CPP_SOURCES *.cpp)

configure_file (qmldir.template qmldir)

add_library (${QML_PLUGIN_NAME} MODULE ${CPP_SOURCES})
qt5_use_modules (${QML_PLUGIN_NAME} Core Widgets Quick Qml )
target_link_libraries (${QML_PLUGIN_NAME}
  -Wl,-rpath,${CMAKE_BINARY_DIR}/libubuntuoneauth
  -L${CMAKE_BINARY_DIR}/libubuntuoneauth
  ${AUTH_LIB_NAME}
)

install (FILES ${CMAKE_CURRENT_BINARY_DIR}/qmldir DESTINATION ${QML_MODULE_INSTALL_DIR}/${QML_MODULE_NAME} )

install (TARGETS ${QML_PLUGIN_NAME} 
  LIBRARY DESTINATION ${QML_MODULE_INSTALL_DIR}/${QML_MODULE_NAME}
  NAMELINK_SKIP
)

install (CODE "execute_process(COMMAND qmlplugindump ${QML_MODULE_NAME} ${QML_PLUGIN_API_VERSION} ${CMAKE_INSTALL_PREFIX}/${QML_MODULE_INSTALL_DIR} OUTPUT_FILE ${CMAKE_INSTALL_PREFIX}/${QML_MODULE_INSTALL_DIR}/${QML_MODULE_NAME}/${QML_MODULE_NAME}.qmltypes)")

add_custom_command(TARGET ${QML_PLUGIN_NAME} POST_BUILD
  COMMAND ${CMAKE_COMMAND} -E create_symlink ${CMAKE_CURRENT_BINARY_DIR} ${QML_MODULE_NAME})

=== libubuntuoneauth/examples/CMakeLists.txt ===
SET (EXAMPLES_TARGET ubuntuoneauth-examples)

SET (SIGNING_EXE "signing-example")

# Qt5 bits
SET (CMAKE_INCLUDE_CURRENT_DIR ON)
SET (CMAKE_AUTOMOC ON)
find_package(Qt5Core REQUIRED)

FILE (GLOB SIGNING_SOURCES signing*.cpp)
FILE (GLOB SIGNING_HEADERS signing*.h)

add_executable (${SIGNING_EXE}
  ${SIGNING_SOURCES}
  ${SIGNING_HEADERS})
qt5_use_modules (${SIGNING_EXE} DBus Network)

target_link_libraries (${SIGNING_EXE}
  -Wl,-rpath,${CMAKE_BINARY_DIR}/libubuntuoneauth
  -L${CMAKE_BINARY_DIR}/libubuntuoneauth
  ${AUTH_LIB_NAME})

add_custom_target(examples-valgrind
    COMMAND "valgrind --tool=memcheck ${CMAKE_CURRENT_BINARY_DIR}/${SIGNING_EXE}"
    DEPENDS ${SIGNING_EXE}
)

add_custom_target(examples-valgrind-leaks
    COMMAND "valgrind --tool=memcheck --track-origins=yes --num-callers=40 --leak-resolution=high --leak-check=full ${CMAKE_CURRENT_BINARY_DIR}/${SIGNING_EXE}"
    DEPENDS ${SIGNING_EXE}
)

=== libubuntuoneauth/tests/CMakeLists.txt ===
# The thing we're building in here
SET (TESTS_TARGET test-ubuntuoneauth)

# Qt5 bits
SET (CMAKE_INCLUDE_CURRENT_DIR ON)
SET (CMAKE_AUTOMOC ON)
find_package(Qt5Core REQUIRED)

# The sources for building the tests
FILE (GLOB SOURCES *.cpp)

add_executable (${TESTS_TARGET} ${SOURCES})
qt5_use_modules (${TESTS_TARGET} Test DBus Network)
target_link_libraries (${TESTS_TARGET}
  -Wl,-rpath,${CMAKE_BINARY_DIR}/libubuntuoneauth
  -L${CMAKE_BINARY_DIR}/libubuntuoneauth
  ${AUTH_LIB_NAME})

configure_file(
  mock_sso_server.py.in
  mock_sso_server.py
)

add_custom_target(ubuntuoneauth-tests
    COMMAND ${CMAKE_CURRENT_BINARY_DIR}/${TESTS_TARGET}
    DEPENDS ${TESTS_TARGET}
)

add_custom_target(ubuntuoneauth-tests-valgrind
    COMMAND valgrind --tool=memcheck ${CMAKE_CURRENT_BINARY_DIR}/${TESTS_TARGET}
    DEPENDS ${TESTS_TARGET}
)

add_custom_target(ubuntuoneauth-tests-valgrind-leaks
    COMMAND valgrind --tool=memcheck --track-origins=yes --num-callers=40 --leak-resolution=high --leak-check=full ${CMAKE_CURRENT_BINARY_DIR}/${TESTS_TARGET}
    DEPENDS ${TESTS_TARGET}
)

=== online-accounts-provider/tests/CMakeLists.txt ===
SET (TESTS_TARGET test-online-accounts-provider)

set (AUTOPILOT_PACKAGE ubuntuone_credentials)

add_custom_target(online-accounts-provider-autopilot-tests
    COMMAND autopilot3 run ${AUTOPILOT_PACKAGE}
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/autopilot
    DEPENDS ${QML_PLUGIN_NAME}
)

add_custom_target(online-accounts-provider-autopilot-tests-local
    COMMAND SSO_AUTH_BASE_URL=fake SSO_UONE_BASE_URL=fake autopilot3 run ${AUTOPILOT_PACKAGE}
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/autopilot
    DEPENDS ${QML_PLUGIN_NAME}
)

add_custom_target(online-accounts-provider-qmlunit-tests
    COMMAND qmltestrunner -input ${CMAKE_CURRENT_SOURCE_DIR}/unit
)

find_package (PythonInterp)

set (AUTOPILOT_DIR autopilot/ubuntuone_credentials)

execute_process (
  COMMAND python3 -c "from distutils import sysconfig; print(sysconfig.get_python_lib())"
  COMMAND sed -r -e "s|^/usr/(local/)?||g"
  OUTPUT_VARIABLE PYTHON_PACKAGE_DIR OUTPUT_STRIP_TRAILING_WHITESPACE)

install (
  DIRECTORY ${AUTOPILOT_DIR}
  DESTINATION ${PYTHON_PACKAGE_DIR}
)

=== debian/changelog ===
ubuntuone-credentials (15.11+16.04.20160323) xenial; urgency=medium

  [ CI Train Bot ]
  * Resync trunk.

  [ Michael Zanetti ]
  * update to uitk 1.3 (LP: #1560621)

  [ Rodney Dawes ]
  * Disable tests on powerpc as something in xenial is causing a crash.

 -- Rodney Dawes <ci-train-bot@canonical.com>  Wed, 23 Mar 2016 19:31:42 +0000

ubuntuone-credentials (15.11+16.04.20151207.1) xenial; urgency=medium

  [ CI Train Bot ]
  * debian/libubuntuoneauth-2.0-0.symbols: update to released version.

  [ Rodney Dawes ]
  * Retrieve current timestamp from server to use in OAuth signatures.
    (LP: #1509118)

 -- Rodney Dawes <ci-train-bot@canonical.com>  Mon, 07 Dec 2015 21:38:01 +0000

ubuntuone-credentials (15.11+16.04.20151202) xenial; urgency=medium

  * Handle the new QtInfoMsg type when compiling against Qt >= 5.5. (LP:
    #1522063)

 -- Rodney Dawes <ci-train-bot@canonical.com>  Wed, 02 Dec 2015 19:29:55 +0000

ubuntuone-credentials (15.11+16.04.20151117.1) xenial; urgency=medium

  [ Rodney Dawes ]
  * Rename the QML module package to match newer naming scheme.

  [ CI Train Bot ]
  * No-change rebuild.

 -- Rodney Dawes <ci-train-bot@canonical.com>  Tue, 17 Nov 2015 21:34:44 +0000

=== debian/control ===
Source: ubuntuone-credentials
Section: libs
Priority: optional
Build-Depends:
 cmake,
 debhelper (>= 9),
 dh-migrations,
 libaccounts-qt5-dev,
 liboauth-dev,
 libsignon-qt5-dev,
 pkg-config,
 qtbase5-dev,
 qtdeclarative5-dev,
 qtdeclarative5-dev-tools,
 qtdeclarative5-ubuntu-ui-toolkit-plugin,
 python3-all:native,
 signon-plugins-dev,
 ubuntu-ui-toolkit-autopilot:native,
 xvfb,
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Ubuntu One Developers <ubuntuone-users@lists.launchpad.net>
Standards-Version: 3.9.5
Vcs-Bzr: lp:ubuntuone-credentials
Xs-Testsuite: autopkgtest
X-Ubuntu-Use-Langpack: yes

Package: ubuntuone-credentials-common
Architecture: all
Multi-Arch: foreign
Pre-Depends:
 multiarch-support,
 ${misc:Pre-Depends},
Depends:
 ubuntuone-client-data (>= 4.2.0),
 ${misc:Depends},
 ${shlibs:Depends},
Description: Ubuntu One authentication library - common data
 A library for native applications to log into the Ubuntu One services,
 to synchronize data, purchase music and software, or access data stored
 remotely on the Ubuntu One servers.
 .
 This package includes common data files for the Ubuntu One authentication
 library and utilities.

Package: ubuntuone-credentials-autopilot
Architecture: all
Depends:
 autopilot-qt5 (>= 1.4+14.10.20140820) | libautopilot-qt (>= 1.4),
 python3-autopilot,
 python3-fixtures,
 python3-testtools,
 qml-module-qtquick2,
 qml-module-qttest,
 qml-module-ubuntuone,
 qml-module-ubuntu-onlineaccounts,
 qtdeclarative5-ubuntu-ui-toolkit-plugin | qtdeclarative5-ubuntu-ui-toolkit-plugin-gles,
 qttestability-autopilot | libautopilot-qt,
 ubuntu-keyboard-autopilot,
 ubuntu-ui-toolkit-autopilot,
 ${misc:Depends},
 ${python:Depends},
 ${shlibs:Depends},
Description: Ubuntu One authentication library - autopilot tests
 A library for native applications to log into the Ubuntu One services,
 to synchronize data, purchase music and software, or access data stored
 remotely on the Ubuntu One servers.
 .
 This package includes the autopilot tests.

Package: libubuntuoneauth-2.0-0
Architecture: any
Multi-Arch: same
Pre-Depends:
 multiarch-support,
 ${misc:Pre-Depends},
Depends:
 account-plugin-tools,
 signon-plugin-password,
 sqlite3,
 ubuntuone-credentials-common (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: Ubuntu One authentication library
 A library for native applications to log into the Ubuntu One services,
 to synchronize data, purchase music and software, or access data stored
 remotely on the Ubuntu One servers.
 .
 This package includes the main library.

Package: libubuntuoneauth-2.0-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Pre-Depends:
 multiarch-support,
 ${misc:Pre-Depends},
Depends:
 libaccounts-qt5-dev,
 liboauth-dev,
 libsignon-qt5-dev,
 libubuntuoneauth-2.0-0 (= ${binary:Version}),
 qtbase5-dev | qtbase5-gles-dev,
 ${misc:Depends},
Description: Ubuntu One authentication library - development files
 A library for native applications to log into the Ubuntu One services,
 to synchronize data, purchase music and software, or access data stored
 remotely on the Ubuntu One servers.
 .
 This package includes the development files for the Ubuntu One authentication
 library.

Package: qml-module-ubuntuone
Architecture: any
Multi-Arch: same
Pre-Depends:
 multiarch-support,
 ${misc:Pre-Depends},
Depends:
 libubuntuoneauth-2.0-0 (= ${binary:Version}),
 qtdeclarative5-ubuntu-ui-toolkit-plugin,
 ${misc:Depends},
 ${shlibs:Depends},
Breaks:
 qtdeclarative5-ubuntuone-credentials-plugin,
 qtdeclarative5-ubuntuone1.0,
Replaces:
 qtdeclarative5-ubuntuone-credentials-plugin,
 qtdeclarative5-ubuntuone1.0,
Description: Ubuntu One authentication library - QML Module
 A library for native applications to log into the Ubuntu One services,
 to synchronize data, purchase music and software, or access data stored
 remotely on the Ubuntu One servers.
 .
 This package includes a Qt declarative plug-in for using the library.

Package: signon-plugin-ubuntuone
Architecture: any
Multi-Arch: foreign
Pre-Depends:
 multiarch-support,
 ${misc:Pre-Depends},
Depends:
 libubuntuoneauth-2.0-0 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: Ubuntu One authentication library - signon plug-in
 A library for native applications to log into the Ubuntu One services,
 to synchronize data, purchase music and software, or access data stored
 remotely on the Ubuntu One servers.
 .
 This package includes an authentication plug-in for the signon daemon.

Package: account-plugin-ubuntuone
Architecture: any
Multi-Arch: foreign
Pre-Depends:
 multiarch-support,
 ${misc:Pre-Depends},
Depends:
 libubuntuoneauth-2.0-0 (= ${binary:Version}),
 qml-module-ubuntuone (= ${binary:Version}),
 ubuntu-system-settings-online-accounts,
 ${misc:Depends},
 ${shlibs:Depends},
Description: Ubuntu One authentication library - account settings plug-in
 A library for native applications to log into the Ubuntu One services,
 to synchronize data, purchase music and software, or access data stored
 remotely on the Ubuntu One servers.
 .
 This package includes the accounts plug-in for Ubuntu System Settings.

=== debian/rules ===
#!/usr/bin/make -f

export DPKG_GENSYMBOLS_CHECK_LEVEL=4
DH_CMAKE_BUILD_DIR=obj-${DEB_BUILD_GNU_TYPE}
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)

ifneq (,$(filter $(DEB_HOST_ARCH), powerpc))
  DEB_BUILD_OPTIONS := nocheck $(DEB_BUILD_OPTIONS)
endif


%:
	dh $@ --buildsystem cmake --fail-missing --with migrations

override_dh_auto_configure:
	dh_auto_configure -- -DLIB_SUFFIX=/$(DEB_HOST_MULTIARCH)

=== debian/tests/control ===
Tests: run-tests
Restrictions: build-needed

## ubuntuone-credentials 15.11+16.10.20160920

=== libubuntuoneauth/CMakeLists.txt ===
--- 
+++ 
@@ -16,7 +16,17 @@
 # The sources for building the library
 FILE (GLOB SOURCES *.cpp)
 # HEADERS only includes the public headers for installation.
-FILE (GLOB HEADERS *.h)
+FILE (GLOB HEADERS
+  errormessages.h
+  identityprovider.h
+  keyring.h
+  logging.h
+  network.h
+  requests.h
+  responses.h
+  ssoservice.h
+  token.h
+)
 
 pkg_check_modules(OAUTH REQUIRED oauth)
 add_definitions(${OAUTH_CFLAGS} ${OAUTH_CFLAGS_OTHER})
@@ -29,12 +39,12 @@
 target_link_libraries (${AUTH_LIB_NAME}
   ${LIBSIGNON_LDFLAGS}
   ${OAUTH_LDFLAGS}
-  -Wl,--version-script -Wl,${CMAKE_CURRENT_SOURCE_DIR}/libubuntuoneauth.symbols
 )
 
 SET_TARGET_PROPERTIES(${AUTH_LIB_NAME} PROPERTIES
   VERSION ${AUTH_LIB_VERSION}
   SOVERSION ${AUTH_LIB_SOVERSION}
+  LINK_FLAGS "-Wl,--version-script -Wl,\"${CMAKE_CURRENT_SOURCE_DIR}/libubuntuoneauth.symbols\""
 )
 
 INSTALL (

=== signon-plugin/tests/CMakeLists.txt ===
# The thing we're building in here
SET (TESTS_TARGET test-ubuntuone-plugin)

# Qt5 bits
SET (CMAKE_INCLUDE_CURRENT_DIR ON)
SET (CMAKE_AUTOMOC ON)
find_package(Qt5Core REQUIRED)

pkg_check_modules(SIGNON REQUIRED signon-plugins)
add_definitions(
    ${SIGNON_CFLAGS}
    ${SIGNON_CFLAGS_OTHER}
    "-DPLUGIN_PATH=\"${CMAKE_CURRENT_BINARY_DIR}/../libubuntuoneplugin.so\""
)

# Workaround for cmake not adding these to automoc properly
SET (CMAKE_AUTOMOC_MOC_OPTIONS "${SIGNON_CFLAGS} ${CMAKE_AUTOMOC_MOC_OPTIONS}")

# The sources for building the tests
SET (SOURCES
    ${SignonPlugin_SOURCE_DIR}/ubuntuone-plugin.cpp
    test_plugin.cpp
)

include_directories( 
    ${SignonPlugin_SOURCE_DIR}
)

add_executable (${TESTS_TARGET} ${SOURCES})
qt5_use_modules (${TESTS_TARGET} Test Network)
target_link_libraries (${TESTS_TARGET}
    -Wl,-rpath,${CMAKE_BINARY_DIR}/libubuntuoneauth
    -L${CMAKE_BINARY_DIR}/libubuntuoneauth
    ${AUTH_LIB_NAME}
    ${SIGNON_LDFLAGS}
)

add_custom_target(ubuntuone-plugin-tests
    COMMAND ${CMAKE_CURRENT_BINARY_DIR}/${TESTS_TARGET}
    DEPENDS ${TESTS_TARGET}
)

add_custom_target(ubuntuone-plugin-tests-valgrind
    COMMAND valgrind --tool=memcheck ${CMAKE_CURRENT_BINARY_DIR}/${TESTS_TARGET}
    DEPENDS ${TESTS_TARGET}
)

add_custom_target(ubuntuone-plugin-tests-valgrind-leaks
    COMMAND valgrind --tool=memcheck --track-origins=yes --num-callers=40 --leak-resolution=high --leak-check=full ${CMAKE_CURRENT_BINARY_DIR}/${TESTS_TARGET}
    DEPENDS ${TESTS_TARGET}
)

=== debian/changelog ===
ubuntuone-credentials (15.11+16.10.20160920) yakkety; urgency=medium

  [ Alberto Mardegan ]
  * Fix the loader to avoid blank page with Qt 5.6. (LP: #1620338)

  [ Rodney Dawes ]
  * Build-Depend on upstart to avoid s390x builds on yakkety.

 -- Rodney Dawes <rodney.dawes@canonical.com>  Tue, 20 Sep 2016 14:17:52 +0000

ubuntuone-credentials (15.11+16.10.20160805.2) yakkety; urgency=medium

  * Skip the timestamp tests for now due to autopkgtests flakiness.

 -- Rodney Dawes <rodney.dawes@canonical.com>  Fri, 05 Aug 2016 16:53:01 +0000

ubuntuone-credentials (15.11+16.10.20160608) yakkety; urgency=medium

  [ Rodney Dawes ]
  * Don't exit 1 on non-errors, and set -e to exit on normal errors.
    (LP: #1503190)
  * Remove the superfluous validateInput method.

  [ Timo Jyrinki ]
  * Stop depending on transitional packages. (LP: #1583079) Run wrap-
    and-sort -a -t -s on the packaging. (LP: #1583079)

 -- Rodney Dawes <rodney.dawes@canonical.com>  Wed, 08 Jun 2016 16:31:42 +0000

ubuntuone-credentials (15.11+16.04.20160427) xenial; urgency=medium

  [ Alberto Mardegan ]
  * Be more explicit about which headers are installed. Move the symbol
    export map to LINK_FLAGS on the target.
  * Complete the UbuntuOne authentication plugin
  * Make Token::isValid() return false on tokens created out of empty
    strings. (LP: #1572943)

 -- Rodney Dawes <ci-train-bot@canonical.com>  Wed, 27 Apr 2016 20:33:37 +0000

=== debian/control ===
--- 
+++ 
@@ -6,16 +6,18 @@
  debhelper (>= 9),
  dh-migrations,
  libaccounts-qt5-dev,
+ libglib2.0-dev,
  liboauth-dev,
  libsignon-qt5-dev,
  pkg-config,
+ python3-all:native,
+ qml-module-ubuntu-components,
  qtbase5-dev,
  qtdeclarative5-dev,
  qtdeclarative5-dev-tools,
- qtdeclarative5-ubuntu-ui-toolkit-plugin,
- python3-all:native,
- signon-plugins-dev,
+ signon-plugins-dev (>= 8.58),
  ubuntu-ui-toolkit-autopilot:native,
+ upstart,
  xvfb,
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: Ubuntu One Developers <ubuntuone-users@lists.launchpad.net>
@@ -51,9 +53,9 @@
  python3-testtools,
  qml-module-qtquick2,
  qml-module-qttest,
+ qml-module-ubuntu-components | qml-module-ubuntu-components-gles,
+ qml-module-ubuntu-onlineaccounts,
  qml-module-ubuntuone,
- qml-module-ubuntu-onlineaccounts,
- qtdeclarative5-ubuntu-ui-toolkit-plugin | qtdeclarative5-ubuntu-ui-toolkit-plugin-gles,
  qttestability-autopilot | libautopilot-qt,
  ubuntu-keyboard-autopilot,
  ubuntu-ui-toolkit-autopilot,
@@ -117,7 +119,7 @@
  ${misc:Pre-Depends},
 Depends:
  libubuntuoneauth-2.0-0 (= ${binary:Version}),
- qtdeclarative5-ubuntu-ui-toolkit-plugin,
+ qml-module-ubuntu-components,
  ${misc:Depends},
  ${shlibs:Depends},
 Breaks:
@@ -135,7 +137,7 @@
 
 Package: signon-plugin-ubuntuone
 Architecture: any
-Multi-Arch: foreign
+Multi-Arch: same
 Pre-Depends:
  multiarch-support,
  ${misc:Pre-Depends},

## ubuntuone-credentials 15.11+17.04.20161107

=== CMakeLists.txt ===
--- 
+++ 
@@ -59,13 +59,13 @@
 # We use $namespace-tests[-valgrind[-leaks]] for the test names in subdirs,
 # and depend on them here, so that 'make check' will run them all.
 add_custom_target(check
-  DEPENDS ubuntuoneauth-tests
+  DEPENDS ubuntuoneauth-tests ubuntuone-plugin-tests
 )
 
 add_custom_target(check-valgrind
-  DEPENDS ubuntuoneauth-tests-valgrind
+  DEPENDS ubuntuoneauth-tests-valgrind ubuntuone-plugin-tests-valgrind
 )
 
 add_custom_target(check-valgrind-leaks
-  DEPENDS ubuntuoneauth-tests-valgrind-leaks
+  DEPENDS ubuntuoneauth-tests-valgrind-leaks ubuntuone-plugin-tests-valgrind-leaks
 )

=== libubuntuoneauth/CMakeLists.txt ===
--- 
+++ 
@@ -31,6 +31,10 @@
 pkg_check_modules(OAUTH REQUIRED oauth)
 add_definitions(${OAUTH_CFLAGS} ${OAUTH_CFLAGS_OTHER})
 
+# Need snapd-glib
+pkg_check_modules(SNAPD REQUIRED snapd-glib)
+add_definitions(${SNAPD_CFLAGS} ${SNAPD_CFLAGS_OTHER})
+
 # Need the project version here
 add_definitions("-DPROJECT_VERSION=\"${PROJECT_VERSION}\"")
 
@@ -39,6 +43,7 @@
 target_link_libraries (${AUTH_LIB_NAME}
   ${LIBSIGNON_LDFLAGS}
   ${OAUTH_LDFLAGS}
+  ${SNAPD_LDFLAGS}
 )
 
 SET_TARGET_PROPERTIES(${AUTH_LIB_NAME} PROPERTIES

=== signon-plugin/CMakeLists.txt ===
project(SignonPlugin)

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-exceptions -fno-rtti")
set(CMAKE_MODULE_LINKER_FLAGS "-Wl,--no-undefined")

# Qt5 bits
SET (CMAKE_INCLUDE_CURRENT_DIR ON)
SET (CMAKE_AUTOMOC ON)
find_package(Qt5Core REQUIRED)

# The sources for building the library
FILE (GLOB SOURCES *.cpp)
# HEADERS only includes the public headers for installation.
FILE (GLOB HEADERS *.h)

pkg_check_modules(SIGNON REQUIRED signon-plugins glib-2.0)
add_definitions(${SIGNON_CFLAGS} ${SIGNON_CFLAGS_OTHER})

# Workaround for cmake not adding these to automoc properly
SET (CMAKE_AUTOMOC_MOC_OPTIONS "${SIGNON_CFLAGS} ${CMAKE_AUTOMOC_MOC_OPTIONS}")

# Need the project version here
add_definitions(
  "-DPROJECT_VERSION=\"${PROJECT_VERSION}\""
  "-DGETTEXT_PACKAGE=\"ubuntuone-credentials\""
)

add_library (${SIGNON_PLUGIN_NAME} MODULE ${SOURCES})
qt5_use_modules (${SIGNON_PLUGIN_NAME} Core Xml Network)
target_link_libraries (${SIGNON_PLUGIN_NAME}
  -Wl,-rpath,${CMAKE_BINARY_DIR}/libubuntuoneauth
  -L${CMAKE_BINARY_DIR}/libubuntuoneauth
  ${AUTH_LIB_NAME}
  ${SIGNON_PLUGIN_LDFLAGS}
  ${SIGNON_LDFLAGS}
  ${SIGNON_LDFLAGS_OTHER}
)

SET (SIGNON_PLUGIN_INSTALL_DIR ${CMAKE_INSTALL_LIBDIR}/signon)

INSTALL (
  TARGETS ${SIGNON_PLUGIN_NAME}
  LIBRARY DESTINATION ${SIGNON_PLUGIN_INSTALL_DIR}
)

add_subdirectory(tests)

=== debian/changelog ===
ubuntuone-credentials (15.11+17.04.20161107) zesty; urgency=medium

  * Use snapd-glib to log in with snapd. (LP: #1637387)
  * Don't do manual tab key handling in the UI. (LP: #1595715)

 -- Rodney Dawes <rodney.dawes@canonical.com>  Mon, 07 Nov 2016 13:48:41 +0000

=== debian/control ===
--- 
+++ 
@@ -9,6 +9,7 @@
  libglib2.0-dev,
  liboauth-dev,
  libsignon-qt5-dev,
+ libsnapd-glib-dev,
  pkg-config,
  python3-all:native,
  qml-module-ubuntu-components,
